class Context {
  Context({Map<String, dynamic> data})
      : this.data = data ?? <String, dynamic>{};
  Context.of(Context context) : data = Map<String, dynamic>.of(context.data);

  final Map<String, dynamic> data;

  dynamic operator [](String key) => data[key];
  void operator []=(String key, dynamic value) {
    data[key] = value;
  }

  bool operator ==(dynamic other) => other is Context && other.data == data;

  @override
  int get hashCode => data.hashCode ^ 371499958;

  @override
  String toString() => 'Context($data)';
}
