import 'utils.dart';

num doAbs(num value) => value.abs();

dynamic doAttr(dynamic value, String attr) {
  if (value is Map) return value[attr];
  return getField(attr, value);
}

String doJoin(Iterable<dynamic> values, [String sep = ' ']) => values.join(sep);

String doLower(dynamic value) => '$value'.toLowerCase();

dynamic doSubList(dynamic value, int start, int end) {
  if (value is List) return value.sublist(start, end);
  if (value is String) return value.substring(start, end);
  throw ArgumentError.value(value, 'value');
}

const FILTERS = <String, Function>{
  'abs': doAbs,
  'attr': doAttr,
  'join': doJoin,
  'lower': doLower,
  'sublist': doSubList,
  // 'batch':                do_batch,
  // 'capitalize':           do_capitalize,
  // 'center':               do_center,
  // 'count':                len,
  // 'd':                    do_default,
  // 'default':              do_default,
  // 'dictsort':             do_dictsort,
  // 'e':                    escape,
  // 'escape':               escape,
  // 'filesizeformat':       do_filesizeformat,
  // 'first':                do_first,
  // 'float':                do_float,
  // 'forceescape':          do_forceescape,
  // 'format':               do_format,
  // 'groupby':              do_groupby,
  // 'indent':               do_indent,
  // 'int':                  do_int,
  // 'last':                 do_last,
  // 'length':               len,
  // 'list':                 do_list,
  // 'title':                do_title,
  // 'map':                  do_map,
  // 'min':                  do_min,
  // 'max':                  do_max,
  // 'pprint':               do_pprint,
  // 'random':               do_random,
  // 'reject':               do_reject,
  // 'rejectattr':           do_rejectattr,
  // 'replace':              do_replace,
  // 'reverse':              do_reverse,
  // 'round':                do_round,
  // 'safe':                 do_mark_safe,
  // 'select':               do_select,
  // 'selectattr':           do_selectattr,
  // 'slice':                do_slice,
  // 'sort':                 do_sort,
  // 'string':               soft_unicode,
  // 'striptags':            do_striptags,
  // 'sum':                  do_sum,
  // 'trim':                 do_trim,
  // 'truncate':             do_truncate,
  // 'unique':               do_unique,
  // 'upper':                do_upper,
  // 'urlencode':            do_urlencode,
  // 'urlize':               do_urlize,
  // 'wordcount':            do_wordcount,
  // 'wordwrap':             do_wordwrap,
  // 'xmlattr':              do_xmlattr,
  // 'tojson':               do_tojson,
};
