import 'utils.dart';

bool testDefined(dynamic value) => asBool(value);

bool testDivisibleBy(num value, num divider) {
  if (divider == 0) return false;
  return value % divider == 0;
}

bool testIn(dynamic value, dynamic seq) {
  if (seq is List) return seq.contains(value);
  if (seq is Map) return seq.containsKey(value);
  if (seq is String) return seq.contains(value as Pattern);
  return false;
}

const TESTS = <String, Function>{
  'defined': testDefined,
  'divisibleby': testDivisibleBy,
  'in': testIn,
  // 'callable': test_callable,
  // 'escaped': test_escaped,
  // 'even': test_even,
  // 'iterable': test_iterable,
  // 'lower': test_lower,
  // 'mapping': test_mapping,
  // 'none': test_none,
  // 'number': test_number,
  // 'odd': test_odd,
  // 'sameas': test_sameas,
  // 'sequence': test_sequence,
  // 'string': test_string,
  // 'undefined': test_undefined,
  // 'upper': test_upper,
};
