import 'dart:mirrors';

bool asBool(dynamic value) {
  if (value == null) return false;
  if (value is bool) return value;
  if (value is num) return value != 0.0;
  if (value is String) return value.isNotEmpty;
  if (value is Iterable) return value.isNotEmpty;
  if (value is Map) return value.isNotEmpty;
  return value != null;
}

bool isNull(dynamic value) => value == null;

dynamic getField(String field, dynamic value) =>
    reflect(value).getField(Symbol(field)).reflectee;

dynamic printIfNotNull(Function function) {
  dynamic res = Function.apply(function, <dynamic>[]);
  if (isNull((res))) return res;
  print((reflect(function) as ClosureMirror).function.simpleName);
  return res;
}

String rprint(dynamic value) => '$value'.replaceAll(RegExp(r'\r\n|\n'), '\\n');
